// ActionScript file
//This file includes functions implementing listeners for the Camera Tracker interactions

import flash.events.Event;
import flash.filters.*;

import lib.FilterEvents.VideoFilterEventClass;

private var currIndx1:int;
private var currIndx2:int;
private var lastFilter:ColorMatrixFilter;



private function addEventListeners():void
{
	//camTracker.addEventListener("VideoFilterEvent", colorfilterCameraEvntHandler);
	camTracker.addEventListener("LeftGesture",leftGesture);
	camTracker.addEventListener("RightGesture",rightGesture);
	camTracker.addEventListener("FaderEvent",onFader);
	camTracker.addEventListener("VideoFilterEvent", colorfilterCameraEvntHandler);
	//
}


//Mode 1 : Previous/Next Gesture
private function leftGesture(event:Event):void
{
	if(this.camTracker.sourceCombo.selectedIndex==0)
		 playPrevious1();
	else
		playPrevious2(); 
}


private function rightGesture(event:Event):void
{	
	if(this.camTracker.sourceCombo.selectedIndex==0)
		 playNext1();
	else
		playNext2(); 

}

//Mode 2: 
private function onFader(event:Event):void
{
	if(this.camTracker.getXPos()!=0)
	{
		var value:Number = this.camTracker.getXPos()/this.camTracker.getVideoWidth();
		this.alphaSlider.value = value;
		if	(systemManager.stage.displayState == StageDisplayState.FULL_SCREEN) 
         this.alphaSliderF.value = value;          
		OnAlpha(value);
	}		
}

//Mode 3: Color filter Handlers
private function colorfilterCameraEvntHandler(event:VideoFilterEventClass):void
{

	if(this.camTracker.sourceCombo.selectedIndex == 0)
		applyColorToVideo1(event.matrix);
	else
		applyColorToVideo2(event.matrix);	
}



private function applyColorToVideo1(matrix:Array):void
{
	var filters:Array = new Array();
	var colorFilter:ColorMatrixFilter = new ColorMatrixFilter();
	vid1.filters =	null;
	if(matrix!=null)
	{
		colorFilter.matrix = matrix;
		//erase previous filter
		filters.push(colorFilter);
		vid1.filters = filters;		
	}
}


private function applyColorToVideo2(matrix:Array):void
{
	var filters:Array = new Array();
	var colorFilter:ColorMatrixFilter = new ColorMatrixFilter();
	vid2.filters =	null;
	if(matrix!=null)
	{
		colorFilter.matrix = matrix;
		//erase previous filter
		filters.push(colorFilter);
		vid2.filters = filters;		
	}
}



