// ActionScript file
//This file contatins the functions for adding youtube videos to playlists and 
//functions to handle the youtube players
import ca.newcommerce.youtube.data.VideoData;

import flash.events.Event;
import flash.events.TimerEvent;
import flash.utils.Timer;

import lib.YouTubeInterface;

import mx.controls.SWFLoader;
import mx.events.DragEvent;

private static var dropColors:Array = ["0x15b711","0x000000"];
private static var defaultColors:Array = ["0x000000","0x000000"];

private var youTubePlayer1:YouTubeInterface;
private var youTubePlayer2:YouTubeInterface;
private var youTubeThumb1:YouTubeInterface;
private var youTubeThumb2:YouTubeInterface;
private var youTubePlaying1:Boolean = false;
private var youTubePlaying2:Boolean = false;
private var swfLoader1:SWFLoader;
private var swfLoader2:SWFLoader;
private var thumbLoader1:SWFLoader;
private var thumbLoader2:SWFLoader;
private var youTubeTimer1:Timer = new Timer(500);
private var youTubeTimer2:Timer = new Timer(500);
private var fileInfoRead1:Boolean = false;
private var fileInfoRead2:Boolean = false;

//Load youtube players
private function initYouTube():void {
	Security.allowDomain("http://www.youtube.com");
	Security.allowDomain("http://gdata.youtube.com");
	Security.loadPolicyFile("http://gdata.youtube.com/crossdomain.xml");
	var w:Number = this.videoUIComp.width;
	var h:Number = this.videoUIComp.height;
	swfLoader1 = new SWFLoader();
	swfLoader2 = new SWFLoader();
	youTubePlayer1 = new YouTubeInterface(this.swfLoader1,w,h);
	youTubePlayer2 = new YouTubeInterface(this.swfLoader2,w,h);   
	
	//setup youtube thumb monitors for loops panel
	thumbLoader1 = new SWFLoader;
	loopCanvas.addChild(thumbLoader1);
	thumbLoader1.visible = false;
	
	
	thumbLoader2 = new SWFLoader;
	this.loopCanvas.addChild(thumbLoader2);
	thumbLoader2.visible = false;
	youTubeThumb1 = new YouTubeInterface(this.thumbLoader1,122,85);
	youTubeThumb2 = new YouTubeInterface(this.thumbLoader2,122,85);
}


private function initYouTubeThumb1():void
{
	thumbLoader1.x = this.thumbVid1.x;
	thumbLoader1.y = this.thumbVid1.y;
	this.youTubeThumb1.setVolume(0);
	this.youTubeThumb1.seekTo(1,false);
	this.youTubeThumb1.pauseVideo();
	this.thumbVid1.visible = false;
	thumbLoader1.visible = true;
}

private function initYouTubeThumb2():void
{
	thumbLoader2.x = this.thumbVid2.x;
	thumbLoader2.y = this.thumbVid2.y;
	this.youTubeThumb2.setVolume(0);
	this.youTubeThumb2.seekTo(1,false);
	this.thumbVid2.visible = false;
	this.youTubeThumb2.pauseVideo();
	thumbLoader2.visible = true;
}


private function resetPlayerSize(player:YouTubeInterface):void
{
	var width:Number = this.videoUIComp.width;
	var height:Number = this.videoUIComp.height;
	
	player.setSize(width, height);
} 


///////////    DRAG AND DROP FUNCTIONS /////////////////////////////////////////////
////Drag and Drop Handlers for playlist1
 private function dragClipExitHandler1(event:DragEvent):void
 {
 	this.vidPlaying1.setStyle("fillColors", defaultColors);
 }

 
 private function playlistDragEnterHandler(event:DragEvent):void
 {
 	var dropTarget:ComboBox = event.currentTarget as ComboBox;
    if(event.dragSource.hasFormat("items"))
    {
    	dropTarget.setStyle("borderThickness", 5);
 		dropTarget.setStyle("fillColors", dropColors); 
 		DragManager.acceptDragDrop(dropTarget);
    }
 }

private function playlist1DropHandler(event:DragEvent):void
{
	var clip:Array = event.dragSource.dataForFormat("items") as Array;
	try{
	var data:VideoData = clip[0];
	}catch (err:Error){
		trace(err);
	}

	if(data!= null)
	{
		var xml:XML = new XML("<clip><title>"+data.title+"</title><file>"+data.actualId+"</file><type>youtube</type></clip>");
 	 	this.playlist1 += xml;
 	}
	this.vidPlaying1.setStyle("fillColors", defaultColors);
}

////Drag and Drop Handlers for playlist2
 private function dragClipExitHandler2(event:DragEvent):void
 {
 	this.vidPlaying2.setStyle("fillColors", defaultColors);
 }


private function playlist2DropHandler(event:DragEvent):void
{
	
	var clip:Array = event.dragSource.dataForFormat("items") as Array;
	try{
	var data:VideoData = clip[0];
	}catch (err:Error){
		trace(err);
	}

	if(data!= null)
	{
		var xml:XML = new XML("<clip><title>"+data.title+"</title><file>"+data.actualId+"</file><type>youtube</type></clip>");
 	 	this.playlist2 += xml;
 	}
	this.vidPlaying2.setStyle("fillColors", defaultColors);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Functions for updating the timer and check for loop starting point
//called by YouTubeTimer running when youtube player is playing
private function youTubeStartUpdate1():void
{	
	this.youTubeTimer1.addEventListener(TimerEvent.TIMER, youTubeUpdate1);
	this.youTubeTimer1.start();
	initYouTubeThumb1();
}

private function youTubeStopUpdate1():void
{
	this.youTubeTimer1.stop();
	this.youTubeTimer1.removeEventListener(TimerEvent.TIMER, youTubeUpdate1);
	this.thumbLoader1.visible = false;
}


//Reading file size and duration for the playback and loop controls
private function ReadFileInfo1():void
{
	if(this.youTubePlayer1.getState()==1)
	{
		this.fileLength1 = this.youTubePlayer1.getDuration();
		this.fileTotalBytes1 = this.youTubePlayer1.getVideoBytesTotal();	
		this.endLoop1 = this.fileLength1;
		this.timeLoopEnd1.text=formatTime(this.fileLength1); 
    	this.endSlider1.value = this.fileLength1;
    	this.progBar1.setProgress(this.youTubePlayer1.getVideoBytesTotal(),this.youTubePlayer1.getVideoBytesTotal());
    	this.fileInfoRead1 = true;
 }		
}

private function youTubeUpdate1(event:Event):void
{
	if(this.fileInfoRead1==false)
		ReadFileInfo1();
	this.playbackProgress1.value = this.youTubePlayer1.getCurrentTime();
	this.timeDisp1.text = formatTime( this.youTubePlayer1.getCurrentTime())+"/"+formatTime(this.youTubePlayer1.getDuration());
	//Check video current time with that of the loop controls
   if(Math.floor(this.youTubePlayer1.getCurrentTime())==Math.floor(endLoop1))
   {
   	 this.youTubePlayer1.seekTo(startLoop1,true);
   } 	
}

//COPY OF ABOVE CODE FOR DECK 2
private function youTubeStartUpdate2():void
{
	ReadFileInfo2();
	this.youTubeTimer2.addEventListener(TimerEvent.TIMER, youTubeUpdate2);
	this.youTubeTimer2.start();
	initYouTubeThumb2();
	
}

private function youTubeStopUpdate2():void
{
	this.youTubeTimer2.stop();
	this.youTubeTimer2.removeEventListener(TimerEvent.TIMER, youTubeUpdate2);
	this.thumbLoader2.visible = false;
}

private function ReadFileInfo2():void
{
	if(this.youTubePlayer2.getState()==1)
	{
		this.fileLength2 = this.youTubePlayer2.getDuration();
		this.fileTotalBytes2 = this.youTubePlayer2.getVideoBytesTotal();	
		this.endLoop2 = this.fileLength2;
		this.timeLoopEnd2.text=formatTime(this.fileLength2); 
    	this.endSlider2.value = this.fileLength2;
    	this.progBar2.setProgress(this.youTubePlayer2.getVideoBytesTotal(),this.youTubePlayer2.getVideoBytesTotal());		
    	this.fileInfoRead2 = true;
	}

}

private function youTubeUpdate2(event:Event):void
{
	if(this.fileInfoRead2==false)
		ReadFileInfo2();
	this.playbackProgress2.value = this.youTubePlayer2.getCurrentTime();
	this.timeDisp2.text = formatTime( this.youTubePlayer2.getCurrentTime())+"/"+formatTime(this.youTubePlayer2.getDuration());
	//Check video current time with that of the loop controls
    if(Math.floor(this.youTubePlayer2.getCurrentTime())==Math.floor(endLoop2))
     {
      this.youTubePlayer2.seekTo(startLoop2,true);
     } 	
}









